SystemOrganization addCategory: #'Magritte-JQueryWidgetBox-Tests'!
SystemOrganization addCategory: #'Magritte-JQueryWidgetBox'!
SystemOrganization addCategory: #'Magritte-JQueryWidgetBox-NFG'!

WAComponent subclass: #MJFunctionalTest
	instanceVariableNames: 'model component'
	classVariableNames: 'SearchObjects'
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-Tests'!

!MJFunctionalTest class methodsFor: 'as yet unclassified' stamp: 'jmck 1/29/2011 12:51'!
buildSearchObjects
	^OrderedCollection new
		add: (MJSearchObject new testValue: 'abcdef'; lookupValue: 'lookup1'; yourself);
		add: (MJSearchObject new testValue: 'abcfed'; lookupValue: 'lookup2'; yourself);
		add: (MJSearchObject new testValue: 'abdef'; lookupValue: 'lookup3'; yourself);
		add: (MJSearchObject new testValue: 'abddef'; lookupValue: 'lookup4'; yourself);
		add: (MJSearchObject new testValue: 'abefg'; lookupValue: 'lookup5'; yourself);
		add: (MJSearchObject new testValue: 'abfdef'; lookupValue: 'lookup6'; yourself);
		yourself
		! !

!MJFunctionalTest class methodsFor: 'as yet unclassified' stamp: 'jmck 1/28/2011 19:54'!
initialize
	"self initialize"
	| app |
	app := WAAdmin register: self asApplicationAt: 'Magritte JQuery Tests'.
	app addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQBaseTheme;
		addLibrary: JQWidgetBoxDeploymentLibrary;
		yourself.
		
	SearchObjects := self buildSearchObjects! !

!MJFunctionalTest methodsFor: 'as yet unclassified' stamp: 'JohnMcKeon 10/4/2010 21:41'!
buildComponent
	^model asComponent
		addValidatedForm;
		yourself! !

!MJFunctionalTest methodsFor: 'as yet unclassified' stamp: 'JohnMcKeon 10/4/2010 21:33'!
children
	^Array with: self component! !

!MJFunctionalTest methodsFor: 'as yet unclassified' stamp: 'JohnMcKeon 10/4/2010 21:33'!
component
	^component ifNil: [ component := self buildComponent ]! !

!MJFunctionalTest methodsFor: 'as yet unclassified' stamp: 'jmck 1/29/2011 12:52'!
initialize
	super initialize.
	model := MJMockObject new! !

!MJFunctionalTest methodsFor: 'as yet unclassified' stamp: 'jmck 1/28/2011 21:16'!
renderContentOn: html
	html heading level: 3; with: 'Magritte JQuery Functional Test'.
	html horizontalRule.
	html render: self component.
	html horizontalRule.
	model date isNil
		ifFalse: [ html paragraph: 'The Date is: ', model date asString ].
	html break.
	model time isNil
		ifFalse: [ html paragraph: 'The Time is: ', model time asString ].
	model searchobject isNil
		ifFalse: [ html paragraph: 'Selected object: ', model searchobject asString ]! !

MAPriorityContainer subclass: #MJTabsContainer
	instanceVariableNames: 'groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-NFG'!

!MJTabsContainer methodsFor: 'private' stamp: 'jmck 12/20/2010 22:17'!
buildChildren
	^self description
		inject: Dictionary new
		into: [ :result :desc | | group |
			(result at: (group := desc group) ifAbsentPut: MAContainer new) add: desc. result ]! !

!MJTabsContainer methodsFor: 'private' stamp: 'jmck 12/20/2010 22:24'!
buildGroups
	^self children
		inject: Dictionary new
		into: [ :result :desc | | group |
			(result at: (group := desc group) ifAbsentPut: MAContainer new) add: desc. result ]! !

!MJTabsContainer methodsFor: 'accessing' stamp: 'jmck 1/20/2011 18:47'!
componentClass
	^MJTabsComponent! !

!MJTabsContainer methodsFor: 'accessing' stamp: 'jmck 1/20/2011 18:46'!
componentRenderer
	^MJTabsRenderer! !

!MJTabsContainer methodsFor: 'accessing' stamp: 'jmck 12/19/2010 12:34'!
groups
	^groups ifNil: [ groups := self buildGroups ]! !

MATextInputComponent subclass: #MJDatepickerComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox'!

!MJDatepickerComponent commentStamp: 'jmck 1/28/2011 18:58' prior: 0!
A MJDatepickerComponent is Magritte component for looking up a date on a MADateDescription using the jQuery datepicker.

Instance Variables
!

!MJDatepickerComponent methodsFor: 'rendering' stamp: 'jmck 1/31/2011 18:06'!
renderInputOn: html
	html textInput
		attributeAt: 'autocomplete' put: 'off';
		id: self labelId;
		on: #string of: self;
		script: (html jQuery new datepicker
			onSelect: (html jQuery ajax serializeThis))! !

MATextInputComponent subclass: #MJTimepickrComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox'!

!MJTimepickrComponent commentStamp: 'jmck 1/28/2011 19:02' prior: 0!
A MJTimepickrComponent is Magritte component for entering a time on a field described by a MATimeDescription using the jQuery timepickr. JQueryWidgetBox-Timepickr is required to use this component.

Instance Variables
!

!MJTimepickrComponent methodsFor: 'rendering' stamp: 'jmck 1/31/2011 18:06'!
renderInputOn: html
	html textInput
		id: self labelId;
		attributeAt: 'autocomplete' put: 'off';
		on: #string of: self;
		script: (html jQuery new timepickr
			select: (html jQuery ajax serializeThis))! !

!MJTimepickrComponent methodsFor: 'rendering' stamp: 'jmck 1/29/2011 00:03'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot javascript url: JQWidgetBoxDeploymentLibrary / #timepickrJs.
	anHtmlRoot stylesheet url: JQWidgetBoxDeploymentLibrary / #timepickrCss.! !

MAOneToManyComponent subclass: #MJGridComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-NFG'!

!MJGridComponent class methodsFor: 'as yet unclassified' stamp: 'jmck 12/18/2010 14:41'!
isAbstract
	^false! !

!MJGridComponent methodsFor: 'private' stamp: 'jmck 12/19/2010 00:22'!
buildColumns
	| columns |
	columns := JQGridColumns new.
	self reference do: [ :desc |
		columns add: ((JQGridColumn
			id: desc label
			label: desc label
			selector: [ :object | (object readUsing: desc) greaseString ])
				"sortable: desc isSortable;"
				editable: desc isReadonly not;
				edittype: desc componentClass edittype;
				editoptions: ((desc respondsTo: #options) ifTrue: [ desc options asJson ] ifFalse: [ nil ]);
				width: desc width; 
				parseBlock: [ :aString | desc fromString: aString ];
				sortId: desc label;
				yourself) ].
	^columns
! !

!MJGridComponent methodsFor: 'rendering' stamp: 'jmck 12/19/2010 00:50'!
doSearch: aSearchRequest using: jqGridColumns
	|filteredData sortedData pagedAndSortedData jqSortColumn|
	jqSortColumn := jqGridColumns columnForSearchRequest: aSearchRequest.
	filteredData := self value.
	aSearchRequest filterCriteriaDo: 
		[:aFilterCrit|
			filteredData 
				removeAllSuchThat: 
					[:each|
						((aFilterCrit jqGridColumn dataValueFor: each)
							perform: aFilterCrit operation with: aFilterCrit filterValue) not]].
	sortedData := 
		filteredData asSortedCollection:
			[:a :b| 
				((jqSortColumn dataValueFor: a) <= (jqSortColumn dataValueFor: b))
					xor: aSearchRequest isSortDescending].
	pagedAndSortedData := sortedData
		copyFrom: aSearchRequest startElementIndex 
		to: ((aSearchRequest endElementIndex) min: filteredData size).
	^JQGridSearchResponse new
		page: aSearchRequest pageNumber;
		totalNumberOfPages: (filteredData size / aSearchRequest numberOfRowsPerPage);
		totalNumberOfRecords: filteredData size;
		rowContents: 
			(pagedAndSortedData 
					collect: [:eachInvoice|
						JQGridRowContent new
							id: eachInvoice id;
							rowObject: eachInvoice])! !

!MJGridComponent methodsFor: 'rendering' stamp: 'jmck 12/19/2010 00:51'!
renderViewerOn: html

	html table
		id: self labelId;
		script: (html jQuery this grid
			searchCallback: [:aSearchRequest :jqGridColumns| self doSearch: aSearchRequest using: jqGridColumns];
			columns: self buildColumns;
			altRows: true;
			rowNum: 20;
			rowList: {5. 10. 20};
			pagerId: 'pager';
			sortname: self reference children first label;
			"toolbarSearch;"
			caption: self description label);
		with:''.
	html div id:'pager'; with: ''.
! !

MAElementComponent subclass: #MJAutocompleteComponent
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox'!

!MJAutocompleteComponent commentStamp: 'jmck 1/29/2011 12:58' prior: 0!
A MJAutocompleteComponent is a Magritte component for looking up an object on a MAToOneRelationDescription using the jQuery autocompleter.
Send #searchFields: to the description to search instances of model objects for matching text in any of the searchFields.
Send #lookupSelector: aSelector to the description to customize the lookup text in the auocompleter list.
Send #updateId: aSymbol to the description to have a script included which updates a div using the description returned by sending to the model object #descriptionASymbol, where 'aSymbol' is the supplied id.

See functional test for an example.


Instance Variables
	items:		a 'temp' variable that stores the collection of found items for a search term. It is a cache to speed up the search for the selected item in #modelFor:
!

!MJAutocompleteComponent class methodsFor: 'as yet unclassified' stamp: 'jmck 1/24/2011 21:00'!
isAbstract
	^false! !

!MJAutocompleteComponent methodsFor: 'initialization' stamp: 'jmck 1/29/2011 14:45'!
initialize
	super initialize.
	items := OrderedCollection new! !

!MJAutocompleteComponent methodsFor: 'rendering' stamp: 'jmck 1/29/2011 11:52'!
lookUp: aDivId
	| component selector |
	selector := ('description', aDivId capitalized) asSymbol.
	component :=  [ self value perform: selector ] on: Error do: [ ^MAUndefinedComponent new ].
	^component asComponentOn: self value! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 1/29/2011 12:37'!
lookupSelector
	"Answer the value of searchFields"

	^ description lookupSelector! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 1/30/2011 22:31'!
modelFor: aTerm
	items isEmptyOrNil ifTrue: [ ^self value ].
	^items detect: [ :each | 
			(each perform: self lookupSelector) = aTerm ] ifNone: [ nil ] 
		! !

!MJAutocompleteComponent methodsFor: 'rendering' stamp: 'jmck 1/30/2011 22:35'!
renderContentOn: html
	| id |
	id := self updateId.
	html textInput
			id: html lastId;
			attributeAt: 'autocomplete' put: 'off';
			class: 'ui-widget-content';
			value: (self value notNil ifTrue: [ self value perform: self lookupSelector ]);
			callback: [ :text | self value: (self modelFor: text) ];
			script: (html jQuery this autocomplete
				sourceCallback: [ :term | self searchResult: term ];
				onClose: (html jQuery ajax
					serializeThis;
					script: [ :s | id isNil ifFalse: [ s << (s jQuery: id) load
						html: (self lookUp: id) ] ] ) ).
	id isNil
		ifFalse: [
			html div
				id: id;
				with: [ self value isNil ifFalse: [ html render: (self lookUp: id) ] ] ]
! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 1/24/2011 21:17'!
searchClass
	^description classes first! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 1/24/2011 20:41'!
searchFields
	"Answer the value of searchFields"

	^ description searchFields! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 1/29/2011 12:37'!
searchResult: searchTerm
	(searchTerm isNil or:[ searchTerm = '']) ifTrue: [ ^ #() ].
	items := self searchClass allInstances
		select: [ :each | 
			self searchFields anySatisfy: [ :fld | | value |
					value := each perform: fld.
					value notNil and: [ value asString asLowercase beginsWith: searchTerm asLowercase ] ] ].
	^items collect: [ :each | each perform: self lookupSelector ]
		
! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 1/29/2011 11:50'!
updateId
	^description updateId! !

MAComponentRenderer subclass: #MJTabsRenderer
	instanceVariableNames: 'selectedGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-NFG'!

!MJTabsRenderer methodsFor: 'rendering' stamp: 'jmck 12/20/2010 22:25'!
renderContainer: aDescription 
	self halt.
	html div
		class: (self classFor: aDescription);
		script: (html jQuery new tabs
			selected: selectedGroup;
			onSelect: (html jQuery ajax 
            		callbackTabs: [ :event | selectedGroup := event at: #index ]));
      with: [
         html unorderedList: [
            aDescription groups keysAndValuesDo: [ :name :group |
               html listItem: [
                  html anchor
                     url: (html jQuery ajax
                        html: [ :h | h render: group ];
                        fullUrl);
                     with: name ] ] ] ]! !

!MJTabsRenderer methodsFor: 'rendering' stamp: 'jmck 12/19/2010 12:51'!
renderControl: aDescription
	html definitionData
		class: (self classFor: aDescription);
		with: [ super renderControl: aDescription ]! !

!MJTabsRenderer methodsFor: 'rendering' stamp: 'jmck 12/19/2010 12:51'!
renderGroup: aDescription
	super renderGroup: aDescription.
	group isNil ifTrue: [ ^ self ].
	html definitionTerm
		class: 'group';
		with: group! !

!MJTabsRenderer methodsFor: 'rendering' stamp: 'jmck 12/19/2010 12:51'!
renderLabel: aDescription
	html definitionTerm
		title: aDescription comment;
		class: (self classFor: aDescription);
		with: [ super renderLabel: aDescription ]! !

MAContainerComponent subclass: #MJTabsComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-NFG'!

!MJTabsComponent methodsFor: 'as yet unclassified' stamp: 'jmck 12/20/2010 22:02'!
buildChildren
	^self description groups associations
		inject: Dictionary new
		into: [ :result :group | 
			result at: group key put: group value asComponent. result ]! !

Object subclass: #MJMockObject
	instanceVariableNames: 'date time searchobject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-Tests'!

!MJMockObject class methodsFor: 'accessing' stamp: 'jmck 1/20/2011 18:44'!
descriptionDate
	^MADateDescription new
		accessor: #date;
		label: 'Date';
		componentClass: MJDatepickerComponent;
		priority: 10;
		yourself! !

!MJMockObject class methodsFor: 'accessing' stamp: 'jmck 1/29/2011 12:52'!
descriptionObject
	^MAToOneRelationDescription new
		accessor: #searchobject;
		label: 'Object';
		classes: (Array with: MJSearchObject);
		componentClass: MJAutocompleteComponent;
		searchFields: #(#testValue);
		updateId: #lookup;
		priority: 1;
		yourself! !

!MJMockObject class methodsFor: 'accessing' stamp: 'jmck 1/20/2011 18:45'!
descriptionTime
	^MATimeDescription new
		accessor: #time;
		label: 'Time';
		componentClass: MJTimepickrComponent;
		priority: 20;
		yourself! !

!MJMockObject methodsFor: 'accessing' stamp: 'JohnMcKeon 10/4/2010 20:46'!
date
	"Answer the value of date"

	^ date! !

!MJMockObject methodsFor: 'accessing' stamp: 'JohnMcKeon 10/4/2010 20:46'!
date: anObject
	"Set the value of date"

	date := anObject! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 1/28/2011 20:31'!
searchobject
	"Answer the value of searchobject"

	^ searchobject! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 1/28/2011 20:31'!
searchobject: anObject
	"Set the value of searchobject"

	searchobject := anObject! !

!MJMockObject methodsFor: 'accessing' stamp: 'JohnMcKeon 10/4/2010 20:46'!
time
	"Answer the value of time"

	^ time! !

!MJMockObject methodsFor: 'accessing' stamp: 'JohnMcKeon 10/4/2010 20:46'!
time: anObject
	"Set the value of time"

	time := anObject! !

Object subclass: #MJSearchObject
	instanceVariableNames: 'testValue lookupValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-Tests'!

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/29/2011 11:22'!
descriptionLookup
	| result |
	result := MAContainer new
		add: self descriptionLookupValue;
		componentRenderer: MACssRenderer;
		yourself.
	^result
		! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/29/2011 11:22'!
descriptionLookupValue
	^MAStringDescription new
		accessor: #lookupValue;
		label: '';
		beReadonly;
		priority: 10;
		yourself! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/29/2011 10:41'!
lookupValue
	"Answer the value of lookupValue"

	^ lookupValue! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/29/2011 10:41'!
lookupValue: anObject
	"Set the value of lookupValue"

	lookupValue := anObject! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/28/2011 19:55'!
printOn: aStream
	aStream nextPutAll: testValue! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/28/2011 19:50'!
testValue
	"Answer the value of testValue"

	^ testValue! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/28/2011 19:50'!
testValue: anObject
	"Set the value of testValue"

	testValue := anObject! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/29/2011 12:46'!
lookupSelector
	"provides for a custom selector to display model objects in the lookup list. Defaults to #displayString"
	^self propertyAt: #lookupSelector ifAbsent: [ #greaseString ]! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/29/2011 12:42'!
lookupSelector: aSelector
	"provides for a custom selector to display model objects in the lookup list. Defaults to #displayString"
	self propertyAt: #lookupSelector put: aSelector! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/25/2011 20:41'!
searchFields
	"Array of selectors to be sent to instances to match against entered search text"
	^self propertyAt: #searchFields ifAbsent: [ Array with: self classes first instVarNames first ]! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/25/2011 20:42'!
searchFields: anArray
	"Array of selectors to be sent to instances to match against search text entered into autocomplete component"
	^self propertyAt: #searchFields put: anArray! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/29/2011 12:44'!
updateId
	"Return an optional id to be updated onClose. Model object MUST implement an instance method that returns a description to be rendered in the update script"
	^self propertyAt: #updateId ifAbsent: [ nil ]! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/29/2011 12:46'!
updateId: aSymbol
	"Provide an optional id to be updated onClose. Model object MUST implement an instance method that returns a description (#descriptionASymbol) to be rendered in the update script."
	self propertyAt: #updateId put: aSymbol! !
MJFunctionalTest initialize!
